package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	
	/**
	 * ...
	 * @author David Williams
	 */
	public class Projectile extends Entity 
	{
		public var damage:Number;
		public var speed:Number;
		private var angle:Number;
		private var xConst:Number = 0;
		private var yConst:Number = 0;
		
		public function Projectile(_dam:Number = 1, _spe:Number = 5) 
		{
			damage = _dam;
			speed = _spe;
			type = "projectile";
		}
		public function shoot(ang:Number):void
		{
			angle = ang * (Math.PI / 180);
			yConst = speed * Math.sin(angle);
			xConst = speed * Math.cos(angle);
			if (graphic is Image)
			{
				(graphic as Image).centerOrigin();
			}
		}
		override public function update():void
		{
			moveBy(xConst, yConst);
			if (x < FP.camera.x || x > FP.camera.x + 640 || FP.camera.y < 0 || y > FP.camera.y + 480 || collide("platform", this.x, this.y)) world.remove(this);
		}
	}

}