package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	/**
	 * ...
	 * @author David Williams
	 */
	public class CameraHandler extends Entity
	{
		private var _target:Entity;
		private var _width:int;
		
		public function CameraHandler(_e:Entity, _w:int = 1280) 
		{
			_target = _e;
			width = _w;
		}
		public function set target(_e:Entity):void
		{
			_target = _e;
		}
		public function get target():Entity
		{
			return _target;
		}
		override public function update():void
		{
			FP.camera.x = this.target.x- (FP.screen.width / 2);
			if (FP.camera.x > (width - FP.screen.width))
			{
				FP.camera.x = width - FP.screen.width;
			}
			if (FP.camera.x < 0)
			{
				FP.camera.x = 0;
			}
		}
		override public function render():void
		{
			
		}
	}

}