package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.masks.Hitbox;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.World;
	import flash.geom.Point;
	import net.flashpunk.FP;
	import net.flashpunk.Entity;
	import net.flashpunk.utils.Draw;
	
	/**
	 * ...
	 * @author David Williams
	 */
	public class TestWorld extends World
	{
		public var playa:Player = new Player(new Point(25, 25));
		private var hitboxes:Boolean = false;
		
		public function TestWorld()
		{
		
		}
		
		override public function begin():void
		{
			super.begin();
			
			add(new CameraHandler(playa));
			add(playa);
			add(new TileLevel());
			
			var b:Projectile = new Projectile(1, 5);
			b.graphic = Image.createRect(5, 5, 0xFFFF77);
			b.mask = new Hitbox(5, 5);
			var gun:WpnBase = new WpnBase(Image.createRect(25, 5, 0xFF3333), b);
			gun.x = 300;
			gun.y = 25;
			add(gun);
			
			var b2:Projectile = new Projectile(1, 4);
			b2.graphic = Image.createRect(6, 6, 0x22FF22);
			b2.mask = new Hitbox(6, 6);
			var gun2:WpnBase = new WpnBase(Image.createRect(22, 7, 0xFF33FF), b2);
			gun2.x = 265;
			gun2.y = 25;
			add(gun2);
			
			var b3:Projectile = new Projectile(1, 7);
			b3.graphic = Image.createRect(3, 3, 0x666666);
			b3.mask = new Hitbox(3, 3);
			var gun3:WpnBase = new WpnBase(Image.createRect(35, 3, 0x33FF33), b3);
			gun3.x = 385;
			gun3.y = 25;
			add(gun3);
		}
		
		override public function update():void
		{
			super.update();
			if (Input.pressed(Key.H))
			{
				hitboxes = !hitboxes;
			}
		}
		override public function render():void
		{
			super.render();
			if (hitboxes)
			{
				var o:Array = new Array();
				getAll(o);
				for each (var e:Entity in o)
				{
					Draw.hitbox(e, true, 0xFF0000, 1);
					Draw.line(playa.gun.x, playa.gun.y, mouseX, mouseY, 0xFF0000);
				}
				
			}
		}
	}

}